Attribute VB_Name = "SYSTEM"
'
' This module contains the definition for several
' constants, together with
' some Windows API function declaration.
'
'


' Windows Common Dialog types
Global Const CD_OPENFILE = 1
Global Const CD_SAVEFILE = 2

Global Const OFN_HIDEREADONLY = &H4&
Global Const OFN_SHOWHELP = &H10&
Global Const OFN_NOVALIDATE = &H100&
Global Const OFN_PATHMUSTEXIST = &H800&
Global Const OFN_FILEMUSTEXIST = &H1000&
Global Const OFN_CREATEPROMPT = &H2000&
Global Const OFN_SHAREAWARE = &H4000&
Global Const OFN_NOREADONLYRETURN = &H8000&

' Screen.MousePointers
Global Const Default = 0        ' 0 - Default
Global Const ARROW = 1          ' 1 - Arrow
Global Const CROSSHAIR = 2      ' 2 - Cross
Global Const IBEAM = 3          ' 3 - I-Beam
Global Const ICON_POINTER = 4   ' 4 - Icon
Global Const HOURGLASS = 11     ' 11 - Hourglass

'
' INI file management functions
'
#If Win16 Then
    Declare Function GetPrivateProfileInt Lib "kernel" (ByVal Appname As String, ByVal KeyName As String, ByVal Default As Integer, ByVal FileName As String) As Integer
    Declare Function GetPrivateProfileString Lib "kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFilename As String) As Integer
    Declare Function WritePrivateProfileString Lib "kernel" (ByVal Appname As String, ByVal KeyName As String, ByVal NewString As String, ByVal FileName As String) As Integer
#Else
    Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal Appname As String, ByVal KeyName As String, ByVal Default As Integer, ByVal FileName As String) As Integer
    Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFilename As String) As Integer
    Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal Appname As String, ByVal KeyName As String, ByVal NewString As String, ByVal FileName As String) As Integer
#End If

' MsgBox parameters
Global Const MB_OK = 0                  ' OK button only
Global Const MB_OKCANCEL = 1            ' OK and Cancel buttons
Global Const MB_ABORTRETRYIGNORE = 2    ' Abort, Retry, and Ignore buttons
Global Const MB_YESNOCANCEL = 3         ' Yes, No, and Cancel buttons
Global Const MB_YESNO = 4               ' Yes and No buttons
Global Const MB_RETRYCANCEL = 5         ' Retry and Cancel buttons

Global Const MB_ICONSTOP = 16           ' Critical message
Global Const MB_ICONQUESTION = 32       ' Warning query
Global Const MB_ICONEXCLAMATION = 48    ' Warning message
Global Const MB_ICONINFORMATION = 64    ' Information message

Global Const MB_APPLMODAL = 0           ' Application Modal Message Box
Global Const MB_DEFBUTTON1 = 0          ' First button is default
Global Const MB_DEFBUTTON2 = 256        ' Second button is default
Global Const MB_DEFBUTTON3 = 512        ' Third button is default
Global Const MB_SYSTEMMODAL = 4096      ' System Modal

' MsgBox return values
Global Const IDOK = 1                   ' OK button pressed
Global Const IDCANCEL = 2               ' Cancel button pressed
Global Const IDABORT = 3                ' Abort button pressed
Global Const IDRETRY = 4                ' Retry button pressed
Global Const IDIGNORE = 5               ' Ignore button pressed
Global Const IDYES = 6                  ' Yes button pressed
Global Const IDNO = 7                   ' No button pressed

' WindowState
Global Const NORMAL = 0                 ' 0 - Normal
Global Const MINIMIZED = 1              ' 1 - Minimized
Global Const MAXIMIZED = 2              ' 2 - Maximized

' Windows help management
#If Win16 Then
Declare Sub WinHelp Lib "user" (ByVal hWnd As Integer, ByVal lpHelpFile As String, ByVal wCommand As Integer, ByVal dwData As Any)
Declare Sub WinHelpString Lib "user" Alias "WinHelp" (ByVal hWnd%, ByVal hlHelpFile$, ByVal wCommand%, ByVal lpstrData$)
#Else
Declare Sub WinHelp Lib "user32" Alias "WinHelpA" (ByVal hWnd As Long, ByVal lpHelpFile$, ByVal wCommand As Long, ByVal dwData As Any)
Declare Sub WinHelpString Lib "user32" Alias "WinHelpA" (ByVal hWnd As Long, ByVal hlHelpFile$, ByVal wCommand As Long, ByVal lpstrData$)
#End If

Global Const APP_HELP_CONTENTS = &H3 ' Display Help for a particular topic
Global Const HELP_CONTEXT = &H1      ' Display topic in ulTopic
Global Const HELP_HELPONHELP = &H4   ' Display help on using help
Global Const HELP_QUIT = &H2         ' Terminate help
Global Const HELP_KEY = &H101        ' Search by key string
Global Const HELP_PARTIALKEY = &H105 ' Search by partial match on key string

